import { Application } from 'express';
import { Resource } from 'express-automatic-routes';
import { ApartmentProvider } from '#providers/ApartmentProvider';
import { Req, Res } from '#interfaces/IApi';
import verify, { requireAdmin } from '#middlewares/auth';
import { validateId } from '#middlewares/validators';
import { Errors } from '#interfaces/error';
import { sendSuccess } from '#utils/responseUtils';

export default (_express: Application) => {
	const apartmentProvider = ApartmentProvider.getInstance();
	return <Resource>{
		delete: {
			middleware: [verify, requireAdmin, validateId],
			handler: async (req: Req, res: Res) => {
				try {
					const apartment = await apartmentProvider.getById({ id: req.params.id! });

					if (!apartment) {
						throw Errors.notFound('Apartment');
					}

					const success = await apartmentProvider.forceDelete(req.params.id!);

					return sendSuccess(res, success);
				} catch (error) {
					return res.error(error);
				}
			},
		},
	};
};
